//============================================================================
// Name        : TestSTLMap.cpp
// Author      :
// Version     :
// Copyright   :
// Description : Hello World in C++, Ansi-style
//============================================================================

#include <iostream>
#include <string>
#include <map>
using namespace std;

bool fncomp (const string& lhs, const string& rhs) {return lhs<rhs;}

// Functor : compartor

// could be a struct instead of a class (there's no need to add public: in this latter case)
class ExamComparator {
	public: bool operator() (const string& lhs, const string& rhs) const
  {
		// return true if lhs comes before rhs
		if( lhs < rhs )
			return true;
		else
			return false;
		// alternative
		// return lhs<rhs;
  }
};


int main() {
	cout << "Test STL Map" << endl; // prints Test STL Map

	map<string,int, ExamComparator> myExams; // Note: ther's no real need for this functor: the default one works OK on strings
	// alternative:
	//map<string,int, bool(*)(const string&, const string&)> myExams(fncomp);

	myExams[ "Analisi I" ] = 28;
	myExams[ "Fondamenti di Informatica I" ] = 30;
	myExams[ "Fisica I" ] = 25;

	//cout << myExams[ "Analisi I" ] << endl;

	map<string,int>::const_iterator itr;
	for( itr = myExams.begin(); itr != myExams.end(); itr++ ) {
		cout << "Esame: " << itr->first << " - Voto: " << (*itr).second << endl;
	}
	map<string, int>::iterator itr2;
	itr2 = myExams.find("Analisi I");
	cout << "Voto: " << (*itr2).second << endl;
	itr2->second = 30;
	cout << "Nuovo voto: " << myExams[ "Analisi I"] << endl;

	return 0;
}
